//
//  mdlWorkOrderFlow.swift
//
//
//  Created by Michiel Carman on 2/16/24.
//


import Fluent
import Vapor
import Foundation
import FluentKit

final class mdlWorkOrderFlow: Model, Content {
    static let schema = "workOrderFlow"
    
    @ID(custom: "id", generatedBy: .database) var id: Int?
    
    @Field(key: "name") var name: String?
    @Field(key: "description") var description: String?
    @Field(key: "sortOrder") var sortorder: Int?
    @Field(key: "isActive") var isactive: Bool?
    
    @Timestamp(key: "createDate", on: .create) var createdate: Date?
    @Field(key: "createUserId") var createuserid: Int?
    @Timestamp(key: "updateDate", on: .update) var updatedate: Date?
    @Field(key: "updateUserId") var updateuserid: Int?
    
    init() { }
    
    init(id: Int? = nil,
         name: String? = nil,
         description: String? = nil,
         sortorder: Int? = nil,
         isactive: Bool? = nil,
         createuserid: Int? = nil,
         updateuserid: Int? = nil
    ) {
        self.id = id
        self.name = name
        self.description = description
        self.sortorder = sortorder
        self.isactive = isactive
        self.createuserid = createuserid
        self.updateuserid = updateuserid
    }
}
extension mdlWorkOrderFlow{
    struct Create: AsyncMigration {
        func prepare(on database: Database) async throws {
            try await database.schema("workOrderFlow")
                .field("id", .int, .identifier(auto: true))
                .field("name", .string)
                .field("description", .string)
                .field("sortOrder", .int)
                .field("isActive", .bool)
                .field("createDate", .datetime)
                .field("createUserId", .int)
                .field("updateDate", .datetime)
                .field("updateUserId", .int)
                .create()
        }
        
        func revert(on database: Database) async throws {
            try await database.schema("workOrderFlow").delete()
        }
    }
    public static func ObjQuery(req: Request) async throws -> QueryBuilder<mdlWorkOrderFlow>{
        
        let query = mdlWorkOrderFlow.query(on: req.db)
//            .with(\.$<#parent/children#>)
        
        if let x = req.parameters.get("x"){
            let decryptedString = try CustomCrypto.DecryptString(input: x)
            let array =  decryptedString.components(separatedBy: ":")
            ///This call is the standard get by id call
            if (array.count == 1){
                let id = Int(array[0])!
                return query.filter(\.$id == id)
            }
            ///Optional else if if there are multiple parameters in the call
            ///You must include an else for each call that has parameters
            ///Need to check the endpoint to get the right filter statements
            ///else if(x.count == 2){
            ///    let username = x[0]
            ///    let password = x[1]
            ///    return query.filter(\.$username == username).filter(\.$password == password)
            ///}
            else{
                throw Abort(.badRequest)
            }
            
        }
        else{
            return query
        }
    }
}

